## BeOS Generic Makefile v2.0 ##

## Fill in this file to specify the project being created, and the referenced
## makefile-engine will do all of the hard work for you.  This handles both
## Intel and PowerPC builds of the BeOS.

## Application Specific Settings ---------------------------------------------

# specify the name of the binary
NAME = csound

# specify the type of binary
#     APP:    Application
#     SHARED: Shared library or add-on
#     STATIC: Static library archive
#     DRIVER: Kernel Driver
TYPE = APP

#     specify the source files to use
#     full paths or paths relative to the makefile can be included
#     all files, regardless of directory, will have their object
#     files created in the common object directory.
#     Note that this means this makefile will not work correctly
#     if two source files with the same name (source.c or source.cpp)
#     are included from different directories.  Also note that spaces
#     in folder names do not work well with this makefile.
WINSRC=   winBe.c
AUDSRC=   rtBe.c BeAudio.c
CSRC1 =   main.c argdecode.c musmon.c otran.c oload.c rdorch.c express.c
CSRC2 = rdscor.c linevent.c cscore.c cscorfns.c insert.c entry1.c entry2.c aops.c
CSRC3 =   midiops.c midirecv.c fgens.c ugens1.c ugens2.c ugens3.c ugens4.c 
CSRC4 =   ugens5.c ugens6.c ugens7.c ugens8.c ugens9.c spectra.c disprep.c
CSRC5 =   window.c winascii.c $(WINSRC) hetro.c lpanal.c lptrkfns.c pvanal.c
CSRC6 =   pvoc.c fft.c dsputil.c sndinfo.c sfheader.c soundin.c soundio.c
CSRC7 =   ulaw.c aiff.c wave.c ieee80.c filopen.c memalloc.c memfiles.c auxfd.c
CSRC8 =   windin.c dumpf.c $(AUDSRC) scot.c scsort.c scxtract.c sread.c sort.c
CSRC9 =   extract.c twarp.c swrite.c butter.c grain.c vdelay.c cmath.c follow.c
CSRCA =   cvanal.c grain4.c pvinterp.c pvread.c sndwarp.c vpvoc.c hrtferX.c
CSRCB =   winEPS.c nlfilt.c opcode.c ugrw1.c ugrw2.c ugensa.c cross2.c dam.c
CSRCC =   midiout.c midiops2.c midisend.c wavegde.c filter.c complex.c repluck.c
CSRCD =   pluck.c physutil.c physmod.c modal4.c shaker.c fm4op.c diskin.c
CSRCE =   pvadd.c moog1.c singwave.c mandolin.c space.c locsig.c dcblockr.c
CSRCF =   pvocext.c flanger.c aifc.c lowpassr.c uggab.c biquad.c one_file.c
CSRCG =   schedule.c midiops3.c pitch.c getstring.c ugsc.c fout.c sndinfUG.c
CSRCH =   pvlook.c scansyn.c sfont.c vbap.c vbap_four.c vbap_eight.c
CSRCI =   vbap_sixteen.c vbap_zak.c control.c bowedbar.c phisem.c sdif.c
CSRCJ = sdif-mem.c babo.c ugmoss.c bbcut.c spat3d.c pvxanal.c mxfft.c
CSRCK = pvsanal.c pstream.c pvfileio.c oscbnk.c scansynx.c oscils.c
CSRCL = wave-terrain.c dnoise.c dnfft.c mididevice.c clfilt.c midiinterop.c

CSRCS =	$(CSRC1) $(CSRC2) $(CSRC3) $(CSRC4) $(CSRC5) $(CSRC6) $(CSRC7) \
          $(CSRC8) $(CSRC9) $(CSRCA) $(CSRCB) $(CSRCC) $(CSRCD) $(CSRCE) \
          $(CSRCF) $(CSRCG) $(CSRCH) $(CSRCI) $(CSRCJ) $(CSRCK) $(CSRCL)

#     specify the resource files to use
#     full path or a relative path to the resource file can be used.
RSRCS = 

#     specify additional libraries to link against
#     there are two acceptable forms of library specifications
#     -       if your library follows the naming pattern of:
#             libXXX.so or libXXX.a you can simply specify XXX
#             library: libbe.so entry: be
#             
#     -       if your library does not follow the standard library
#             naming scheme you need to specify the path to the library
#             and it's name
#             library: my_lib.a entry: my_lib.a or path/my_lib.a
LIBS = 
              
#     specify additional paths to directories following the standard
#     libXXX.so or libXXX.a naming scheme.  You can specify full paths
#     or paths relative to the makefile.  The paths included may not
#     be recursive, so include all of the paths where libraries can
#     be found.  Directories where source files are found are
#     automatically included.
LIBPATHS = 

#     additional paths to look for system headers
#     these use the form: #include <header>
#     source file directories are NOT auto-included here
SYSTEM_INCLUDE_PATHS = 

#     additional paths to look for local headers
#     these use the form: #include "header"
#     source file directories are automatically included
LOCAL_INCLUDE_PATHS = ../Server

#     specify the level of optimization that you desire
#     NONE, SOME, FULL
OPTIMIZE = FULL

#     specify any preprocessor symbols to be defined.  The symbols
#     will be set to a value of 1.  For example specify DEBUG if you want
#     DEBUG=1 to be set when compiling.
DEFINES = SFIRCAM SYS5 O_NDELAY=O_NONBLOCK PIPES MACROS WINDOWS RTAUDIO

#     specify special warning levels
#     if unspecified default warnings will be used
#     NONE = supress all warnings
#     ALL = enable all warnings
WARNINGS = 

#     specify whether image symbols will be created
#     so that stack crawls in the debugger are meaningful
#     if TRUE symbols will be created
SYMBOLS = 

#     specify debug settings
#     if TRUE will allow application to be run from
#     a source-level debugger
DEBUGGER = 

#     specify additional compiler flags for all files
COMPILER_FLAGS = 

#     specify additional linker flags
LINKER_FLAGS = 

#     Targets - the normal top-level target is 'default'.

all:	default csound.xmg

## include the makefile-engine
include /boot/develop/etc/makefile-engine

American.xmg: all_strings $(OBJ_DIR) $(OBJ_DIR)/makedb
	$(OBJ_DIR)/makedb all_strings American

English.xmg:  english-strings $(OBJ_DIR) $(OBJ_DIR)/makedb
	$(OBJ_DIR)/makedb english-strings English

csound.xmg:	all_strings English.xmg
	cp English.xmg csound.xmg
#	cp American.xmg csound.xmg

makedb:	makedb.c text.h
	$(CC) -o makedb makedb.c

$(OBJ_DIR)/makedb: $(OBJ_DIR)/makedb.o
	$(LD) -o $@ $< $(LDFLAGS)

install:	all
	mkdir -p $(INSTDIR)
	install -m 755 $(TARGET) $(INSTDIR)
	install -m 644 csound.xmg $(INSTDIR)
	mimeset $(INSTDIR)
