#include "cs.h"                 /*                              INSERT.C        */
#include "insert.h"     /* for goto's */
#include "aops.h"       /* for cond's */
#include "midiops.h"
#include <string.h>             /* for memset() */

#ifdef mills_macintosh
#include "MacTransport.h"
#endif

static MYFLT cpu_power_busy=FL(0.0);  /* accumulates the supposed percent of cpu usage */
/* extern  INSDS *insalloc[]; */
extern  OPARMS  O;

INSDS   *instance(int);

/* glob int     tieflag = 0;               toggled by insert for tigoto */
static  int     reinitflag = 0;         /* toggled by reinit for others */
static  OPDS    *ids, *pds;             /* used by init and perf loops  */
                                        /*  & modified by igoto, kgoto  */
static  OPDS    opdstmp;
void    showallocs(void);
extern  void    putop(TEXT*);
void    deact(INSDS *), schedofftim(INSDS *);
int     sensOrcEvent(void);     /* For triginstr (re Aug 1999) */
/* IV - Sep 8 2002: these variables store the global values of variables */
/* depending on ksmps, so they can be accessed while user defined opcodes */
/* with a local ksmps are active. schedule, event, and similar opcodes */
/* should use these values. */
int     global_ksmps;
MYFLT   global_ensmps, global_ekr, global_onedkr, global_hfkprd, global_kicvt;
long    global_kcounter;

void insertRESET(void)
{
    memset(&actanchor,0,sizeof(INSDS));
    curip          = NULL;
    frstoff        = NULL;
    kcounter       = 0;
    inerrcnt       = 0;
    perferrcnt     = 0;
    tieflag        = 0;
    reinitflag     = 0;
    ids            = NULL;
    pds            = NULL;
    cpu_power_busy = FL(0.0);
    /* don't forget local externs in this file... */
}

int init0(void)
{
    INSDS  *ip;

    curip = ip = instance(0);               /* allocate instr 0     */
    ids = (OPDS *)ip;
    while ((ids = ids->nxti) != NULL) {
      (*ids->iopadr)(ids);            /*   run all i-code     */
    }
    return(inerrcnt);                       /*   return errcnt      */
}

int
insert(int insno, EVTBLK *newevtp)  /* insert an instr copy into active list */
{                                   /*      then run an init pass           */
    INSTRTXT *tp;
    INSDS  *ip, *prvp, *nxtp;

    VMSG(printf("activating instr %d\n",insno);)
    inerrcnt = 0;
    tp = instrtxtp[insno];
    if (tp->mdepends & 04) {
      printf(Str(X_925,"instr %d expects midi event data, cannot run from score\n"),
             insno);
      return(1);
    }
    if ((ip = tp->instance) != NULL) {      /* if allocs of text exist: */
      do      if (ip->insno == insno  /*   if find this insno,  */
                  && ip->actflg         /*      active            */
                  && ip->offtim < 0     /*      with indef (tie)  */
                  && ip->p1 == newevtp->p[1]){ /*  & matching p1  */
        tieflag++;
        goto init;      /*     continue that event */
      }
      while ((ip = ip->nxtinstance) != NULL);
      ip = tp->instance;              /*   else get alloc of text */
      do      if (!ip->actflg)        /*      that is free        */
        goto actlnk;    /*      and use its space   */
      while ((ip = ip->nxtinstance) != NULL);
    }
    /* RWD: screen writes badly slow down RT playback */
    if (O.msglevel & 2) printf(Str(X_1013,"new alloc for instr %d:\n"),insno);
    ip = instance(insno);                   /* else alloc new dspace  */

 actlnk:
    cpu_power_busy += instrtxtp[insno]->cpuload;
    if (cpu_power_busy > 100.0) { /* if there is no more cpu processing time*/
      cpu_power_busy -= instrtxtp[insno]->cpuload;
      warning(Str(X_26,
                  "cannot allocate last note because it exceeds 100% of cpu time"));
      return(0);
    }
        /* Add an active instrument */
    if (instrtxtp[insno]->active++ > instrtxtp[insno]->maxalloc &&
        instrtxtp[insno]->maxalloc>0) {
      instrtxtp[insno]->active--;
      warning(Str(X_27,
                  "cannot allocate last note because it exceeds instr maxalloc"));
      return(0);
    }

#ifdef never
    printf("Now %d active instr %d\n", instrtxtp[insno]->active, insno);
#endif
    ip->insno = insno;
    nxtp = &actanchor;                      /* now splice into activ lst */
    while ((prvp = nxtp) && (nxtp = prvp->nxtact) != NULL)
      if (nxtp->insno > insno
          || nxtp->insno == insno
          && nxtp->p1 > newevtp->p[1]) {
        nxtp->prvact = ip;
        break;
      }
    ip->nxtact = nxtp;
    ip->prvact = prvp;
    prvp->nxtact = ip;
    ip->actflg++;                   /*    and mark the instr active */
    {
      int    n;
      MYFLT  *flp, *fep;

    init:
      if (tp->psetdata) {
        MYFLT *pfld = &ip->p3;              /* if pset data present */
        MYFLT *pdat = tp->psetdata + 2;
        long nn = tp->pmax - 2;             /*   put cur vals in pflds */
        do {
          *pfld++ = *pdat++;
        } while (nn--);
      }
      if ((n = tp->pmax) != newevtp->pcnt && !tp->psetdata) {
        /* was "instr %d pmax = %d, note pcnt = %d" */
        sprintf(errmsg,Str(X_928,"instr %d uses %d p-fields but is given %d"),
                insno, n, newevtp->pcnt);
        warning(errmsg);
      }
      if (newevtp->p3orig >= 0.0)
        ip->offbet = newevtp->p2orig + newevtp->p3orig;
      else ip->offbet = FL(-1.0);
      flp = &ip->p1;
      fep = &newevtp->p[1];
      VMSG(printf("psave beg at %p\n",flp);)
        do  *flp++ = *fep++;            /* psave        */
        while (--n);
        VMSG(printf("   ending at %p\n",flp);)
    }
    ip->offtim = ip->p3;                    /* & duplicate p3 for now */
    ip->xtratim = 0;
    ip->relesing = 0;
    ip->m_chnbp = (MCHNBLK*) NULL;  /* IV May 2002 */
    ip->opcod_iobufs = NULL;        /* IV - Sep 8 2002 */
    curip = ip;
    ids = (OPDS *)ip;
    while ((ids = ids->nxti) != NULL) {   /* do init pass for this instr */
       VMSG({printf("init %s:\n", opcodlst[ids->optext->t.opnum].opname);})
      (*ids->iopadr)(ids);
    }
    tieflag = 0;
    if (inerrcnt || !ip->p3) {
      deact(ip);
      return(inerrcnt);
    }
    if (ip->p3 > FL(0.0) && ip->offtim > FL(0.0)) {   /* if still finite time, */
      ip->offtim = ip->p2 + ip->p3;
      schedofftim(ip);                    /*   put in turnoff list */
    }
    else ip->offtim = -FL(1.0);                      /* else mark indef */
    VMSG({  printf("instr %d now active:\n",insno); showallocs(); })
    return(0);
}

int MIDIinsert(int insno, MCHNBLK *chn, MEVENT *mep)
    /* insert a MIDI instr copy into active list */
    /*  then run an init pass           */
{
    INSTRTXT *tp;
    INSDS    *ip, **ipp;

    cpu_power_busy += instrtxtp[insno]->cpuload;
    if (cpu_power_busy > FL(100.0)) { /* if there is no more cpu processing time*/
      cpu_power_busy -= instrtxtp[insno]->cpuload;
      warning(
         Str(X_26,
             "cannot allocate last note because it exceeds 100%% of cpu time"));
      return(0);
    }
    VMSG(printf("activating instr %d\n",insno);)
    inerrcnt = 0;
    ipp = &chn->kinsptr[mep->dat1];         /* key insptr ptr           */
    tp = instrtxtp[insno];
    if (tp->instance != NULL) {             /* if allocs of text exist  */
      INSDS **spp;
      if ((ip = *ipp) != NULL) {          /*   if key currently activ */
        if (ip->xtratim == 0)           /*     if decay not needed  */
          goto m_dat2;                /*        usurp curr space  */
        else goto forcdec;              /*     else force a decay   */
      }
      spp = ipp + 128;                    /*   (struct dependent ! )  */
      if ((ip = *spp) != NULL) {          /*   else if pch sustaining */
        *spp = NULL;                    /*     remov from sus array */
        chn->ksuscnt--;
        if (ip->xtratim == 0) {
          *ipp = ip;
          goto m_dat2;
        }
        else {
        forcdec:
          ip->relesing = 1;           /*     else force a decay   */
          ip->offtim = (kcounter + ip->xtratim) * onedkr;
          schedofftim(ip);
          Mforcdecs++;
        }
      }                                   /*         & get new space  */
      ip = tp->instance;                  /*    srch existing allocs  */
      do  if (!ip->actflg)                /*      if one is free      */
        goto actlnk;                /*      then use its space  */
      while ((ip = ip->nxtinstance) != NULL);
    }
    printf(Str(X_1013,"new alloc for instr %d:\n"),insno);
    ip = instance(insno);                   /* else alloc new dspace  */

 actlnk:
    ip->insno = insno;
    if (instrtxtp[insno]->active++ > instrtxtp[insno]->maxalloc &&
        instrtxtp[insno]->maxalloc>0) {
      instrtxtp[insno]->active--;
      warning(Str(X_27,
                  "cannot allocate last note because it exceeds instr maxalloc"));
      return(0);
    }
#ifdef never
    printf("Now %d active instr %d\n", instrtxtp[insno]->active, insno);
#endif
    {
      INSDS  *prvp, *nxtp;       /* now splice into activ lst */
      nxtp = &actanchor;
      while ((prvp = nxtp) && (nxtp = prvp->nxtact) != NULL)
        if (nxtp->insno > insno) {
          nxtp->prvact = ip;
          break;
        }
      ip->nxtact = nxtp;
      ip->prvact = prvp;
      prvp->nxtact = ip;
    }
    ip->actflg++;           /*    and mark the instr active */
    if (tp->pmax > 3 && tp->psetdata==NULL) {
      sprintf(errmsg,Str(X_927,"instr %d p%d illegal for MIDI"),
              insno, tp->pmax);
      warning(errmsg);
    }
    ip->m_chnbp = chn;      /* rec address of chnl ctrl blk */
    *ipp = ip;              /* insds ptr for quick midi-off */
    ip->m_pitch = mep->dat1; /* rec MIDI data               */
 m_dat2:
    ip->m_veloc = mep->dat2;
    ip->xtratim = 0;
    ip->relesing = 0;
    ip->offtim = -FL(1.0);       /* set indef duration */
    ip->opcod_iobufs = NULL;        /* IV - Sep 8 2002:            */
    ip->p1 = (MYFLT) ip->insno;     /* set these required p-fields */
    ip->p2 = (MYFLT) kcounter * onedkr;
    ip->p3 = FL(-1.0);
    if (tp->psetdata != NULL) {
      MYFLT *pfld = &ip->p3;              /* if pset data present */
      MYFLT *pdat = tp->psetdata + 2;
      long nn = tp->pmax - 2;             /*   put cur vals in pflds */
      do {
        *pfld++ = *pdat++;
      } while (nn--);
    }
    curip = ip;
    ids = (OPDS *)ip;
    while ((ids = ids->nxti) != NULL) { /* do init pass for this instr  */
      VMSG(printf("init %s:\n", opcodlst[ids->optext->t.opnum].opname);)
      (*ids->iopadr)(ids);
    }
    tieflag = 0;
    if (inerrcnt) {
      deact(ip);
      return(inerrcnt);
    }
    VMSG( { printf("instr %d now active:\n",insno); showallocs(); } )
    return(0);
}

void showallocs(void)    /* debugging aid        */
{
    INSTRTXT *txtp;
    INSDS   *p;

    printf("insno\tinstanc\tnxtinst\tprvinst\tnxtact\t"
           "prvact\tnxtoff\tactflg\tofftim\n");
    for (txtp = &instxtanchor;  txtp != NULL;  txtp = txtp->nxtinstxt)
      if ((p = txtp->instance) != NULL) {
        /*
         * On Alpha, we print pointers as pointers.  heh 981101
         * and now on all platforms (JPff)
         */
        do  printf("%d\t%p\t%p\t%p\t%p\t%p\t%p\t%d\t%3.1f\n",
                   (int)p->insno, p,
                   p->nxtinstance,
                   p->prvinstance, p->nxtact,
                   p->prvact, p->nxtoff,
                   p->actflg, p->offtim);
        while ((p = p->nxtinstance) != NULL);
      }
}

void schedofftim(INSDS *ip)     /* put an active instr into offtime list  */
                                /* called by insert() & midioff + xtratim */
{
    INSDS *prvp, *nxtp;

    if ((nxtp = frstoff) == NULL
        || nxtp->offtim > ip->offtim)          /*   set into      */
      frstoff = ip;                       /*   firstoff chain */
    else {
      while ((prvp = nxtp)
             && (nxtp = nxtp->nxtoff) != NULL
             && ip->offtim >= nxtp->offtim);
      prvp->nxtoff = ip;
    }
    ip->nxtoff = nxtp;
}


void insxtroff(short insno)     /* deactivate all schedofftim copies    */
{                               /*  (such as xtratims still playing)    */
    INSDS *ip, *prvp;

    for (ip = frstoff; ip != NULL; ip = ip->nxtoff) {
      if (ip->insno == insno && ip->actflg) {
        deact(ip);
        if (frstoff == ip)
          frstoff = ip->nxtoff;
        else prvp->nxtoff = ip->nxtoff;
      }
      else prvp = ip;
    }
}

void subinstrset(SUBINST*);             /* IV - Sep 8 2002 */
void useropcdset(UOPCODE*);

void deact(INSDS *ip)           /* unlink single instr from activ chain */
                                /*      and mark it inactive            */
{                               /*   close any files in fd chain        */
    INSDS  *nxtp;
    OPDS   *p;

/*     printf("active(%d) = %d\n", ip->insno, instrtxtp[ip->insno]->active); */
    instrtxtp[ip->insno]->active--;     /* remove an active instrument */
    cpu_power_busy -= instrtxtp[ip->insno]->cpuload;
    /* IV - Sep 8 2002: free subinstr instances */
    /* that would otherwise result in a memory leak */
    for (p = ip->nxti; p != NULL; p = p->nxti) {
      if (p->iopadr == (SUBR) useropcdset) {    /* IV - Sep 8 2002 */
        if (((UOPCODE*) p)->ip != NULL) {
          deact(((UOPCODE*) p)->ip);
          ((UOPCODE*) p)->ip = NULL;
        }
      }
      else if (p->iopadr == (SUBR) subinstrset) {
        if (((SUBINST*) p)->ip != NULL) {
          deact(((SUBINST*) p)->ip);
          ((SUBINST*) p)->ip = NULL;
        }
      }
    }
#if 0
    printf("removed instance of instr %d\n", ip->insno);
#endif
    if ((nxtp = ip->prvact->nxtact = ip->nxtact) != NULL)
      nxtp->prvact = ip->prvact;
    ip->actflg = 0;
    if (ip->fdch.nxtchp != NULL)
      fdchclose(ip);
}

void beatexpire(MYFLT beat)     /* unlink expired notes from activ chain */
{                               /*      and mark them inactive          */
    INSDS  *ip, *nxtp;     /*    close any files in each fdchain   */

    if ((ip = frstoff) != NULL && ip->offbet <= beat) {
      do {
        deact(ip);      /* IV - Sep 5 2002: use deact() as it also */
      }                 /* deactivates subinstrument instances */
      while ((ip = ip->nxtoff) != NULL && ip->offbet <= beat);
      frstoff = ip;
      VMSG( { printf("deactivated all notes to beat %7.3f\n",beat);
      printf("frstoff = %p\n",frstoff);  } )
    }
}

void timexpire(MYFLT time)      /* unlink expired notes from activ chain */
{                               /*      and mark them inactive           */
    INSDS  *ip, *nxtp;          /*    close any files in each fdchain    */

    if ((ip = frstoff) != NULL && ip->offtim <= time) {
      do {
        deact(ip);      /* IV - Sep 5 2002: use deact() as it also */
      }                 /* deactivates subinstrument instances */
      while ((ip = ip->nxtoff) != NULL && ip->offtim <= time);
      frstoff = ip;
      VMSG( { printf("deactivated all notes to time %7.3f\n",time);
      printf("frstoff = %p\n",frstoff); } )
        }
}

void ihold(void)                        /* make this note indefinit duration */
{                                       /* called by ihold statmnt at Itime */
        if (!reinitflag) {              /* no-op at reinit                  */
                curip->offbet = -FL(1.0);
                curip->offtim = -FL(1.0);
        }
}

void turnoff(void)                      /* terminate the current instrument  */
{                                       /* called by turnoff statmt at Ptime */
    INSDS  *lcurip = pds->insdshead;
    if (lcurip->xtratim) {               /* if extra time needed:  */
      INSDS *nxt;
      MYFLT oldtim = lcurip->offtim;
      MYFLT newtim = (kcounter + lcurip->xtratim) * onedkr;
/* printf("Turnoff called %d offtime %f->%f\n", lcurip->xtratim,oldtim,newtim); */
      lcurip->relesing = 1;
      lcurip->offtim = newtim;
      if (oldtim < FL(0.0))             /* if indef duratn instr   */
        schedofftim(lcurip);             /*    schedoff at new time */
      else if ((nxt = lcurip->nxtoff) != NULL
               && newtim > nxt->offtim) {
        INSDS *prv, *newip = nxt;       /* else relink if reqd  */
        while ((prv = nxt)
               && (nxt = nxt->nxtoff) != NULL
               && newtim > nxt->offtim);
        prv->nxtoff = lcurip;
        lcurip->nxtoff = nxt;
        if (lcurip == frstoff)
          frstoff = newip;
      }
      lcurip->xtratim--;         /* Decay the delay */
    }
    else {                                /* no extra time needed:  */
      INSDS   *ip, *prvip;
      MCHNBLK *chn;
      short   pch;
      deact(lcurip);                       /* deactivate immediately */
      if ((chn = lcurip->m_chnbp) != NULL
          && (pch = lcurip->m_pitch)) {    /* if this was a MIDI note */
        INSDS **ipp = &chn->kinsptr[pch];
        if (*ipp == lcurip) *ipp = NULL;   /*    remov from activ lst */
        else if (chn->ksuscnt) {
          ipp += 128;                     /* STRUCT DEPEND */
          if (*ipp == lcurip) {
            *ipp = NULL;                  /*    or from sustain list */
            chn->ksuscnt--;
          }
        }
      }
      if (lcurip->offtim >= FL(0.0)      /* skip indefinite durs    */
          && (ip = frstoff) != NULL) {
        if (ip == lcurip)                /* else rm from nxtoff chn */
          frstoff = ip->nxtoff;
        else while ((prvip = ip) && (ip = ip->nxtoff) != NULL)
          if (ip == lcurip) {
            prvip->nxtoff = ip->nxtoff;
            break;
          }
      }
    }
}

void xturnoff(INSDS *ip)                /* turnoff a particular insalloc */
{                                       /* called by inexclus on ctrl 111 */
    pds = &opdstmp;
    pds->insdshead = ip;
    turnoff();
}

void insdealloc(short insno)      /* dealloc all instances of an insno */
{                                 /*   called by midirecv on pgm_chng  */
    INSDS   *ip, *nxtip;

    if ((ip = instrtxtp[insno]->instance) != NULL) {
      do {                              /* for all instances: */
        if (ip->actflg)                 /* if active, deact   */
          deact(ip);                    /*    & close files   */
        if (ip->auxch.nxtchp != NULL)
          auxchfree(ip);                /* free auxil space   */
        nxtip = ip->nxtinstance;
        free((char *)ip);               /* & free the INSDS   */
      } while ((ip = nxtip) != NULL);
      instrtxtp[insno]->instance = NULL;/* now there are none */
    }
}

void orcompact(void)                    /* free all inactive instr spaces */
{
    INSTRTXT *txtp;
    INSDS   *ip, *nxtip, *prvip, **prvnxtloc;

    for (txtp = &instxtanchor;  txtp != NULL;  txtp = txtp->nxtinstxt)
      if ((ip = txtp->instance) != NULL) {        /* if instance exists */
        prvip = NULL;
        prvnxtloc = &txtp->instance;
        do {
          if (ip->actflg == 0) {
            OPDS* off = ip->nxtp;
            while (off!=NULL) {
              if (off->dopadr) (*off->dopadr)(off);
              off = off->nxtp;
            }
            if (ip->fdch.nxtchp != NULL)
              fdchclose(ip);
            if (ip->auxch.nxtchp != NULL)
              auxchfree(ip);
            if ((nxtip = ip->nxtinstance) != NULL)
              nxtip->prvinstance = prvip;
            *prvnxtloc = nxtip;
            mfree((char *)ip);
          }
          else {
            prvip = ip;
            prvnxtloc = &ip->nxtinstance;
          }
        }
        while ((ip = *prvnxtloc) != NULL);
      }
    printf(Str(X_897,"inactive allocs returned to freespace\n"));
}

void infoff(MYFLT p1)           /*  turn off an indef copy of instr p1  */
{                               /*      called by musmon                */
    INSDS *ip;
    int   insno;

    insno = (int)p1;
    if ((ip = (instrtxtp[insno])->instance) != NULL) {
      do if (ip->insno == insno          /* if find the insno */
             && ip->actflg                 /*      active       */
             && ip->offtim < 0             /*      but indef,   */
             && ip->p1 == p1) {
        if (ip->xtratim && ip->offbet < 0)    { /* Gab: delays the off event is xtratim > 0 */
#include "schedule.h"
          MYFLT starttime;
          EVTNODE *evtlist, *newnode;
          EVTBLK  *newevt;

          newnode         = (EVTNODE *) mmalloc((long)sizeof(EVTNODE));
          newevt          = &newnode->evt;
          newevt->opcod   = 'i';
          starttime       = (MYFLT) (kcounter + ip->xtratim) * onedkr;
          newnode->kstart = kcounter + ip->xtratim;
          newevt->p2orig  = starttime;
          newevt->p3orig  = FL(0.0);
          newevt->p[1]    = (MYFLT) -insno; /* negative p1 */
          newevt->p[2]    = starttime;    /* Set actual start time in p2 */
          newevt->p[3]    = FL(0.0);
          newevt->pcnt    = 2;
          newnode->insno  = insno;
          evtlist         = &OrcTrigEvts;
          while (evtlist->nxtevt) {
            if (newnode->kstart < evtlist->nxtevt->kstart) break;
            evtlist = evtlist->nxtevt;
          }
          newnode->nxtevt = evtlist->nxtevt;
          evtlist->nxtevt = newnode;
          O.RTevents      = 1;     /* Make sure kperf() looks for RT events */
          O.ksensing      = 1;
          O.OrcEvts       = 1;
          ip->offbet      = 0; /* to avoid another check */
          ip->relesing    = 1;
          return;
        }
        VMSG(printf("turning off inf copy of instr %d\n",insno);)
        deact(ip);
        return;                     /*  turn it off */
      } while ((ip = ip->nxtinstance) != NULL);
    }
    printf(Str(X_669,"could not find indefinitely playing instr %d\n"),insno);
}

#ifdef nver
#define numClockPoints 32
static double clocksPerFrame[numClockPoints];
static double clocks = 0;
static int cpfIndex = 0;
static int temp = 0;
static clock_t lastClock = 0;
#endif

long kperf(long kcnt)   /* perform currently active instrs for kcnt kperiods */
                        /*      & send audio result to output buffer    */
{
    extern  int     sensLine(void);
    extern  int     sensMidi(void), sensFMidi(void);
    extern  void    (*spinrecv)(void), (*spoutran)(void), (*nzerotran)(long);
    INSDS  *ip;
    long    kreq = kcnt;
#ifdef never
    clock_t clockStart = clock();
    clock_t clockEnd;
#endif

    VMSG(printf("perfing %ld kprds\n",kcnt);)
    if (!O.ksensing && actanchor.nxtact == NULL) {  /* if !kreads & !instrs_activ, */
      kcounter += kcnt;
      global_kcounter = kcounter;       /* IV - Sep 8 2002 */
#if defined(mills_macintosh) || defined(CWIN) || defined(SYMANTEC)
      /* silence here, so we can afford to check events more often */
      {
        long pcnt = kcnt;
        while (pcnt!=0) {
          long pp = (pcnt>128 ? 128 : pcnt);
          (*nzerotran)(pp);     /*   send chunk up to kcnt zerospouts  */
          if (!POLL_EVENTS()) longjmp(cglob.exitjmp,1);
          pcnt -= pp;
        }
      }
#else
      (*nzerotran)(kcnt);     /*   send kcnt zerospouts  */
#endif
    }
    else do {                 /* else for each kcnt:     */
      if (O.RTevents) {
        if (O.Midiin && (sensType = sensMidi()) /*   if MIDI note message  */
            || O.FMidiin && kcounter >= FMidiNxtk
            && (sensType = sensFMidi())
            || O.Linein && (sensType = sensLine()) /* or Linein event */
            || O.OrcEvts && (sensType = sensOrcEvent())) /* or triginstr event (re Aug 1999) */
          return(kreq - kcnt); /*      do early return    */
      }
#if defined(mills_macintosh) || defined(CWIN) || defined(SYMANTEC)
      else if (O.Midiin && actanchor.nxtact == NULL) /* no midi or notes on; check events */
        if (!POLL_EVENTS()) longjmp(cglob.exitjmp,1);
#endif
      kcounter += 1;
      global_kcounter = kcounter;       /* IV - Sep 8 2002 */
      if (O.sfread)           /*   if audio_infile open  */
        (*spinrecv)();        /*      fill the spin buf  */
      spoutactive = 0;        /*   make spout inactive   */
      ip = &actanchor;
      while ((ip = ip->nxtact) != NULL) { /*   for each instr active */
#ifdef CWIN
        if (!POLL_EVENTS()) longjmp(cglob.exitjmp,1); /* PC GUI needs attention */
#endif
        pds = (OPDS *)ip;
        while ((pds = pds->nxtp) != NULL) {
          (*pds->opadr)(pds); /*      run each opcode    */
        }
      }
      if (spoutactive)        /*   results now in spout? */
        (*spoutran)();        /*      send to audio_out  */
      else (*nzerotran)(1L);  /*   else send zerospout   */
    } while (--kcnt);         /* on Mac/Win, allow system events */
#ifdef never
    clockEnd = clock();
    clocksPerFrame[cpfIndex] = (clockEnd - clockStart)/(double)(kreq*ksmps);
    if (++cpfIndex == numClockPoints)
      cpfIndex = 0;
    /* average this into our tally */
    clocks = clocks*.9 + (clockEnd - clockStart)*.1/(double)(kreq*ksmps);
    /* test printouts */
    /*	temp += kreq;
    if (temp > ekr*.05)	{
      int i;
      double total = 0;

      for (i = 0; i < numClockPoints; i++)
	total += clocksPerFrame[i];

      printf("cpu load is: %f\n", esr*total/(double)(numClockPoints*CLOCKS_PER_SEC));
      printf("cpu load[filt]: %f\n", esr*clocks/(double)(CLOCKS_PER_SEC));
      printf("rendering rate is: %f\n", (double)(CLOCKS_PER_SEC*temp)/(ekr*(clockEnd - lastClock)));
      lastClock = clockEnd;
      temp = 0;
    }
*/
#endif
    return(kreq);
}

void initerror(char *s)
{
    /* RWD: need this! */
    if (ids==NULL) {
      dies(Str(X_551,"\nINIT ERROR: %s\n"),s);
    }
    printf(Str(X_299,"INIT ERROR in instr %d: %s\n"), ids->insdshead->insno, s);
    putop(&ids->optext->t);
    inerrcnt++;
}

void perferror(char *s)
{
    /*RWD and probably this too... */
    if (pds==NULL) {
      dies(Str(X_553,"\nPERF ERROR: %s\n"),s);
    }
    printf(Str(X_403,"PERF ERROR in instr %d: %s\n"), pds->insdshead->insno, s);
    putop(&pds->optext->t);
    printf(Str(X_7,"   note aborted\n"));
    perferrcnt++;
    deact(pds->insdshead);                    /* rm ins fr actlist */
    while (pds->nxtp != NULL)
      pds = pds->nxtp;                        /* loop to last opds */
}                                             /* contin from there */

void igoto(GOTO *p)
{
    ids = p->lblblk->prvi;
}

void kgoto(GOTO *p)
{
    pds = p->lblblk->prvp;
}

void icgoto(CGOTO *p)
{
    if (*p->cond)
      ids = p->lblblk->prvi;
}

void kcgoto(CGOTO *p)
{
    if (*p->cond)
      pds = p->lblblk->prvp;
}

/* an 'if-then' variant of 'if-goto' */
void ingoto(CGOTO *p)
{
    if (!*p->cond)
      pds = p->lblblk->prvp;
}

void kngoto(CGOTO *p)
{
    if (!*p->cond)
      pds = p->lblblk->prvp;
}

void timset(TIMOUT *p)
{
    if ((p->cnt1 = (long)(*p->idel * ekr + .5)) < 0L
        || (p->cnt2 = (long)(*p->idur * ekr + .5)) < 0L)
      initerror(Str(X_1012,"negative time period"));
}

void timout(TIMOUT *p)
{
    if (p->cnt1)                            /* once delay has expired, */
      p->cnt1--;
    else if (--p->cnt2 >= 0L)               /*  br during idur countdown */
      pds = p->lblblk->prvp;
}

void rireturn(LINK *p)
{
    IGN(p);
}

void reinit(GOTO *p)
{
    reinitflag = 1;
    curip = p->h.insdshead;
    ids = p->lblblk->prvi;        /* now, despite ANSI C warning:  */
    while ((ids = ids->nxti) != NULL && ids->iopadr != (SUBR)rireturn)
      (*ids->iopadr)(ids);
    reinitflag = 0;
}

void rigoto(GOTO *p)
{
    if (reinitflag)
      ids = p->lblblk->prvi;
}

void tigoto(GOTO *p)                    /* I-time only, NOP at reinit */
{
    if (tieflag && !reinitflag)
      ids = p->lblblk->prvi;
}

void tival(EVAL *p)                     /* I-time only, NOP at reinit */
{
    if (!reinitflag)
      *p->r = (tieflag ? FL(1.0) : FL(0.0));
}

/* IV - Sep 8 2002: restored old subinstrument functions */

void subinstrset(SUBINST *p)
{
    OPDS    *saved_ids = ids;
    INSDS	*saved_curip = curip;
    MYFLT	*flp;
    int instno = 0, n;
    INSTRNAME *inm = instrumentNames;

    p->outtypes = 0;
    p->intypes = 0;	
    p->outchans = nchnls;
    if (nchnls > p->OUTOCOUNT)
      p->outchans = p->OUTOCOUNT;

    if (strcmp(p->h.optext->t.opcod, "subinstr") == 0) {
      p->usingNumberedInstr = 1;
      instno = (int)*p->ar[SUBINSTNUMOUTS];
    }
    else { /* look up the 'fake' instr number */
      p->usingNumberedInstr = 0;
      while (inm) {
        if (strcmp(p->h.optext->t.opcod, inm->name) == 0) {
          instno = inm->instno;
          /* save the i/o types if defined */
          if (inm->ip->t.inlist->count == 3) {
            p->outtypes = inm->ip->t.inlist->arg[1];
            p->intypes = inm->ip->t.inlist->arg[2];
          }
          break;
        }
        inm = inm->prv;
      }
    }

    if (!instno)
      dies("Cannot Find Instrument %s\n", p->h.optext->t.opcod);

    p->ip = instance(instno);               /* allocate instr     */
    p->ip->p1 = p->ip->insno = instno;
    p->ip->actflg++;                   /*    and mark the instr active */
    curip = p->ip;
    ids = (OPDS *)p->ip;

    /* copy parameters from this instrument into our subinstrument */
    p->ip->xtratim = saved_curip->xtratim;
    p->ip->relesing = saved_curip->relesing;
    p->ip->offbet = saved_curip->offbet;
    p->ip->offtim = saved_curip->offtim;
    p->ip->p2 = saved_curip->p2;
    p->ip->p3 = saved_curip->p3;

    /* i think we want subinstr to NOT be midi..  ?? */
    p->ip->m_chnbp = NULL;
    p->ip->m_pitch = 0;
    p->ip->m_veloc = 0;

    /* copy remainder of pfields        */
    flp = &p->ip->p3 + 1;
    if (p->intypes) {
      char *type = p->intypes;
      for (n = p->usingNumberedInstr; n < p->INOCOUNT; n++, type++) {
        if (*type == 'i' || *type == 'p')
          *flp++ = *p->ar[SUBINSTNUMOUTS+n];
      }
    }
    else {	/* by default all inputs are i-rate mapped to p-fields */
      for (n = p->usingNumberedInstr; n < p->INOCOUNT; n++)
        *flp++ = *p->ar[SUBINSTNUMOUTS+n];
    }

    /* allocate memory for a temporary store of spout buffers */
    auxalloc((long)nspout*sizeof(MYFLT), &p->saved_spout);
    auxalloc((long)nspin*sizeof(MYFLT), &p->saved_spin);

    /* do init pass for this instr */
    while ((ids = ids->nxti) != NULL) {
      (*ids->iopadr)(ids);
    }

    /* restore globals */
    ids = saved_ids;
    curip = saved_curip;
}

extern MYFLT  kspin[VARGMAX];
extern MYFLT  kspout[VARGMAX];
void subinstr(SUBINST *p)
{
    OPDS    *saved_pds = pds;
    int		saved_sa = spoutactive;
    MYFLT	saved_kspin[VARGMAX], saved_kspout[VARGMAX];
    long	kbufsize = VARGMAX*sizeof(MYFLT);
    MYFLT *flp = &p->ip->p3 + 1;
    long 	n, frame, chan;

    /* copy current spout buffer and clear it */
    memcpy(p->saved_spout.auxp, spout, p->saved_spout.size);
    memset(spout, 0, p->saved_spout.size);
    memcpy(p->saved_spin.auxp, spin, p->saved_spin.size);
    memset(spin, 0, p->saved_spin.size);
    memcpy(saved_kspin, kspin, kbufsize);
    memset(kspin, 0, VARGMAX*sizeof(MYFLT));
    memcpy(saved_kspout, kspout, kbufsize);
    memset(kspout, 0, VARGMAX*sizeof(MYFLT));
	
    /* copy inputs       */
    if (p->intypes) {
      long kndx = 0;
      MYFLT *chan = spin; /* current start channel of spin buf */
      MYFLT *buf;
      char *type = p->intypes;
      for (n = p->usingNumberedInstr; n < p->INOCOUNT; n++, type++) {
        switch (*type) {
        case 'i':	/* do not change pfield */
          flp++;
          break;
        case 'k':	/* save to use with 'ink' opcode */
          kspin[kndx++] = *p->ar[p->OUTOCOUNT+n];
          break;
        case 'p': 	/* change the pfield at k-rate */
          *flp++ = *p->ar[p->OUTOCOUNT+n];
          break;
        case 'a':	/* write to spin */
          for (frame = 0, buf = chan; frame < ksmps; frame++, buf += nchnls) {
            *buf = p->ar[p->OUTOCOUNT+n][frame];
          }
          chan++;
          break;
        }
      }
    }

    /*  run each opcode  */
    pds = (OPDS *)p->ip;
    while ((pds = pds->nxtp) != NULL) {
      (*pds->opadr)(pds);
    }

    /* copy outputs */
    if (p->outtypes) {
      MYFLT	*pbuf = spout;
      char *type = p->outtypes;
      int knum = 0;

      chan = 0;
      while (*type) {
        if (*type == 'k') {	/* copy from 'outk' output */
          *p->ar[chan] = kspout[knum];
          knum++;
        }
        else if (*type == 'a') { /* copy the spout to our output */
          for (frame = 0; frame < ksmps; frame++) {
            p->ar[chan][frame] = pbuf[chan];
            pbuf += nchnls;
          }
        }
        type++;
        chan++;
      }
    }


    /* restore spouts */
    memcpy(spout, p->saved_spout.auxp, p->saved_spout.size);
    memcpy(spin, p->saved_spin.auxp, p->saved_spin.size);
    memcpy(kspout, saved_kspout, kbufsize);
    memcpy(kspin, saved_kspin, kbufsize);
    spoutactive = saved_sa;
    pds = saved_pds;
}

/* IV - Sep 8 2002: new functions for user defined opcodes (based */
/* on Matt J. Ingalls' subinstruments, but mostly rewritten) */

void useropcd1(UOPCODE*), useropcd2(UOPCODE*);  /* IV - Sep 17 2002 */

void useropcdset(UOPCODE *p)
{
    OPDS    *saved_ids = ids;
    INSDS   *saved_curip = curip;
    int     instno = 0, i, n, inchns, outchns, perf_pcnt;
    char    *intypes, *outtypes, *tmp, *opcodnam;
    INSTRNAME *inm = instrumentNames;
    int     g_ksmps;
    MYFLT   g_ensmps, g_ekr, g_onedkr, g_hfkprd, g_kicvt;

    /* need to subtract one from the input channels due to the optional */
    /* argument for local ksmps */
    inchns = p->INOCOUNT - 1;
    outchns = p->OUTOCOUNT;
    intypes = outtypes = NULL;
    g_ksmps = p->l_ksmps = ksmps;       /* default ksmps */
    p->ksmps_scale = 1;
    opcodnam = p->h.optext->t.opcod;    /* opcode name */
    /* look up the 'fake' instr number */
    while (inm) {
      if (strcmp(opcodnam, inm->name) == 0) {
        instno = inm->instno;
        /* save the i/o types */
        outtypes = inm->ip->t.inlist->arg[1];
        intypes = inm->ip->t.inlist->arg[2];
        break;
      }
      inm = inm->prv;
    }
    /* this should never occur */
    if (opcodnam == NULL || inm == NULL || intypes == NULL || outtypes == NULL
        || !instno) {
      initerror("internal error: opcode not found");
      return;
    }
    /* set local ksmps if defined by user */
    if (*(p->ar[outchns + inchns]) != FL(0.0)) {
      p->l_ksmps = (int) *(p->ar[outchns + inchns]);
      if (p->l_ksmps < 1 || p->l_ksmps > ksmps
          || ((ksmps / p->l_ksmps) * p->l_ksmps) != ksmps) {
        sprintf(errmsg, "%s: invalid local ksmps value: %d",
                        opcodnam, p->l_ksmps);
        initerror(errmsg);
        return;
      }
    }
    /* save old globals */
    g_ensmps = ensmps;
    g_ekr = ekr; g_onedkr = onedkr; g_hfkprd = hfkprd; g_kicvt = kicvt;
    /* set up local variables depending on ksmps, also change globals */
    if (p->l_ksmps != g_ksmps) {
      ksmps = p->l_ksmps;
      p->ksmps_scale = g_ksmps / (int) ksmps;
      p->l_ensmps = ensmps = pool[O.poolcount + 2] = (MYFLT) p->l_ksmps;
      p->l_ekr = ekr = pool[O.poolcount + 1] = esr / p->l_ensmps;
      p->l_onedkr = onedkr = FL(1.0) / p->l_ekr;
      p->l_hfkprd = hfkprd = FL(0.5) / p->l_ekr;
      p->l_kicvt = kicvt = (MYFLT) FMAXLEN / p->l_ekr;
      kcounter = kcounter * p->ksmps_scale;
    }
    /* allocate memory for I/O buffers (to be used by xin and xout) */
    /* IV - Sep 8 2002: store only pointers to the input and output  */
    /* arguments of the opcode (saves some unneeded memory copying). */
    /* This assumes that local pool is not relocated during */
    /* performance (which is currently the case). */
    n = sizeof(OPCOD_IOBUFS) + sizeof(MYFLT*) * (inchns + outchns);
    /* perf time I/O addresses are set up by xinset and xoutset, so */
    /* need to allocate memory for these too (including the 4 NULLs */
    /* that delimit the address lists) */
    for (perf_pcnt = i = 0; i < inchns; i++)
      if (intypes[i] == 'a' || intypes[i] == 'k' || intypes[i] == 'K')
        perf_pcnt++;
    for (i = 0; i < outchns; i++)
      if (outtypes[i] == 'a' || outtypes[i] == 'k' || outtypes[i] == 'K')
        perf_pcnt++;
    perf_pcnt = (perf_pcnt << 1) + 4;
    n += sizeof(MYFLT*) * perf_pcnt;
    auxalloc((long) n, &p->iobufs);
    /* set up pointers to I/O buffers */
    tmp = (char*) p->iobufs.auxp;
    p->buf = (OPCOD_IOBUFS*) tmp; tmp += sizeof(OPCOD_IOBUFS);
    /* input buffers */
    p->buf->inbufs = (MYFLT**) tmp; tmp += sizeof(MYFLT*) * inchns;
    for (i = 0; i < inchns; i++)
      p->buf->inbufs[i] = p->ar[outchns + i];
    /* output buffers */
    p->buf->outbufs = (MYFLT**) tmp; tmp += sizeof(MYFLT*) * outchns;
    for (i = 0; i < outchns; i++)
      p->buf->outbufs[i] = p->ar[i];
    /* perf-time buffers */
    p->buf->iobufp_ptrs = (MYFLT**) tmp; tmp += sizeof(MYFLT*) * perf_pcnt;
    /* initialise perf time address lists */
    p->buf->iobufp_ptrs[0] = NULL; p->buf->iobufp_ptrs[1] = NULL;
    p->buf->iobufp_ptrs[2] = NULL; p->buf->iobufp_ptrs[3] = NULL;
    /* store parameters of input and output channels */
    p->buf->inchans = inchns;
    p->buf->outchans = outchns;
    p->buf->intypes = intypes;
    p->buf->outtypes = outtypes;

    /* check if there is enough space for copying p-fields */
    if (instrtxtp[instno]->pmax < instrtxtp[saved_curip->insno]->pmax) {
      /* extend */
      instrtxtp[instno]->pmax = instrtxtp[saved_curip->insno]->pmax;
      instrtxtp[instno]->pextrab =
#ifdef __alpha__
      /* On Alpha we need to align at 2*sizeof(float) (i.e. 64 bits).   *
       * So we round up.  heh 981101                                    */
        (short) (((instrtxtp[instno]->pmax | 1) - 3) * sizeof(MYFLT));
#else
        (short) ((instrtxtp[instno]->pmax - 3) * sizeof(MYFLT));
#endif
      p->ip = NULL;     /* need to allocate a new instance */
    }
    else {
      /* search for already allocated, but not active instance */
      p->ip = instrtxtp[instno]->instance;
      while (p->ip != NULL) {
        if (!(p->ip->actflg)) break;
        p->ip = p->ip->nxtinstance;
      }
    }
    /* if none was found, allocate a new instance */
    if (p->ip == NULL) p->ip = instance(instno);
    p->ip->insno = instno;
    p->ip->actflg = 1;                  /*    and mark the instr active */
    (instrtxtp[instno]->active)++;
    curip = p->ip;
    p->ip->opcod_iobufs = (void*) p->buf;
    p->ip->prvact = p->ip; p->ip->nxtact = NULL;/* hack to avoid deact crash */
    ids = (OPDS *) (p->ip->nxti);

    /* copy parameters from the caller instrument into our subinstrument */
    p->parent_ip = saved_curip;
    n = (int) saved_curip->xtratim * p->ksmps_scale;
    p->ip->xtratim = (short) (n > 32767 ? 32767 : n);
    p->ip->relesing = saved_curip->relesing;
    p->ip->offbet = saved_curip->offbet;
    p->ip->offtim = saved_curip->offtim;
    /* copy all p-fields, including p1 (will this work ?) */
    memcpy(&(p->ip->p1), &(saved_curip->p1),
           (size_t) (instrtxtp[saved_curip->insno]->pmax * sizeof(MYFLT)));

    p->ip->m_chnbp = saved_curip->m_chnbp;      /* MIDI parameters */
    p->ip->m_pitch = saved_curip->m_pitch;
    p->ip->m_veloc = saved_curip->m_veloc;

    /* do init pass for this instr */
    while (ids != NULL) {
      (*ids->iopadr)(ids);
      ids = ids->nxti;
    }
    /* check if setksmps was called during init pass */
    if (ksmps != p->l_ksmps) {
      /* update parameters if needed */
      p->ksmps_scale = g_ksmps / (int) ksmps;
      p->l_ksmps = ksmps; p->l_ensmps = ensmps;
      p->l_ekr = ekr; p->l_onedkr = onedkr; p->l_hfkprd = hfkprd;
      p->l_kicvt = kicvt;
    }

    /* restore globals */
    ids = saved_ids;
    curip = saved_curip;
    if (ksmps != g_ksmps) {
      ksmps = g_ksmps; ensmps = pool[O.poolcount + 2] = g_ensmps;
      ekr = pool[O.poolcount + 1] = g_ekr;
      onedkr = g_onedkr; hfkprd = g_hfkprd; kicvt = g_kicvt;
      kcounter = kcounter / p->ksmps_scale;
      /* IV - Sep 17 2002: also select perf routine */
      p->h.opadr = (SUBR) useropcd1;
    }
    else
      p->h.opadr = (SUBR) useropcd2;
}

/* IV - Sep 17 2002 -- case 1: local ksmps is used */

void useropcd1(UOPCODE *p)
{
    OPDS    *saved_pds = pds;
    int     g_ksmps, ofs = 0, n;
    MYFLT   g_ensmps, g_ekr, g_onedkr, g_hfkprd, g_kicvt, **tmp, *ptr1, *ptr2;
    long    g_kcounter;

    /* update release flag */
    p->h.insdshead->relesing = p->parent_ip->relesing;
    /* save old globals */
    g_ksmps = ksmps; g_ensmps = ensmps;
    g_ekr = ekr; g_onedkr = onedkr; g_hfkprd = hfkprd; g_kicvt = kicvt;
    g_kcounter = kcounter;
    /* set local ksmps and related values */
    ksmps = p->l_ksmps; ensmps = pool[O.poolcount + 2] = p->l_ensmps;
    ekr = pool[O.poolcount + 1] = p->l_ekr;
    onedkr = p->l_onedkr; hfkprd = p->l_hfkprd; kicvt = p->l_kicvt;
    kcounter = kcounter * p->ksmps_scale;

    if (ksmps == 1) {                   /* special case for local kr == sr */
      do {
        /* copy inputs */
        tmp = p->buf->iobufp_ptrs;
        while (*tmp) {                  /* a-rate */
          ptr1 = *(tmp++) + ofs; *(*(tmp++)) = *ptr1;
        }
        while (*(++tmp)) {              /* k-rate */
          ptr1 = *tmp; *(*(++tmp)) = *ptr1;
        }
        /*  run each opcode  */
        pds = (OPDS *) (p->ip->nxtp);
        while (pds != NULL) {
          (*pds->opadr)(pds);
          pds = pds->nxtp;
        }
        /* copy outputs */
        while (*(++tmp)) {              /* a-rate */
          ptr1 = *tmp; (*(++tmp))[ofs] = *ptr1;
        }
        ++kcounter;
      } while (++ofs < g_ksmps);
    }
    else {                              /* generic case for local kr != sr */
      do {
        /* copy inputs */
        tmp = p->buf->iobufp_ptrs;
        while (*tmp) {                  /* a-rate */
          ptr1 = *(tmp++) + ofs; ptr2 = *(tmp++);
          n = ksmps;
          do {
            *(ptr2++) = *(ptr1++);
          } while (--n);
        }
        while (*(++tmp)) {              /* k-rate */
          ptr1 = *tmp; *(*(++tmp)) = *ptr1;
        }
        /*  run each opcode  */
        pds = (OPDS *) (p->ip->nxtp);
        while (pds != NULL) {
          (*pds->opadr)(pds);
          pds = pds->nxtp;
        }
        /* copy outputs */
        while (*(++tmp)) {              /* a-rate */
          ptr1 = *tmp; ptr2 = *(++tmp) + ofs;
          n = ksmps;
          do {
            *(ptr2++) = *(ptr1++);
          } while (--n);
        }
        ++kcounter;
      } while ((ofs += ksmps) < g_ksmps);
    }
    /* k-rate outputs are copied only in the last sub-kperiod, */
    /* so we do it now */
    while (*(++tmp)) {                  /* k-rate */
      ptr1 = *tmp; *(*(++tmp)) = *ptr1;
    }

    /* restore globals */
    ksmps = g_ksmps; ensmps = pool[O.poolcount + 2] = g_ensmps;
    ekr = pool[O.poolcount + 1] = g_ekr;
    onedkr = g_onedkr; hfkprd = g_hfkprd; kicvt = g_kicvt;
    kcounter = g_kcounter;
    pds = saved_pds;
}

/* IV - Sep 17 2002 -- case 2: simplified routine for no local ksmps */

void useropcd2(UOPCODE *p)
{
    OPDS    *saved_pds = pds;
    int     n;
    MYFLT   **tmp, *ptr1, *ptr2;

    /* update release flag */
    p->h.insdshead->relesing = p->parent_ip->relesing;

    tmp = p->buf->iobufp_ptrs;
    if (ksmps != 1) {                   /* generic case for kr != sr */
      /* copy inputs */
      while (*tmp) {                    /* a-rate */
        ptr1 = *(tmp++); ptr2 = *(tmp++);
        n = ksmps;
        do {
          *(ptr2++) = *(ptr1++);
        } while (--n);
      }
      while (*(++tmp)) {                /* k-rate */
        ptr1 = *tmp; *(*(++tmp)) = *ptr1;
      }
      /*  run each opcode  */
      pds = (OPDS *) (p->ip->nxtp);
      while (pds != NULL) {
        (*pds->opadr)(pds);
        pds = pds->nxtp;
      }
      /* copy outputs */
      while (*(++tmp)) {                /* a-rate */
        ptr1 = *tmp; ptr2 = *(++tmp);
        n = ksmps;
        do {
          *(ptr2++) = *(ptr1++);
        } while (--n);
      }
    }
    else {                      /* special case for kr == sr */
      /* copy inputs */
      while (*tmp) {                    /* a-rate */
        ptr1 = *(tmp++); *(*(tmp++)) = *ptr1;
      }
      while (*(++tmp)) {                /* k-rate */
        ptr1 = *tmp; *(*(++tmp)) = *ptr1;
      }
      /*  run each opcode  */
      pds = (OPDS *) (p->ip->nxtp);
      while (pds != NULL) {
        (*pds->opadr)(pds);
        pds = pds->nxtp;
      }
      /* copy outputs */
      while (*(++tmp)) {                /* a-rate */
        ptr1 = *tmp; *(*(++tmp)) = *ptr1;
      }
    }
    while (*(++tmp)) {                  /* k-rate */
      ptr1 = *tmp; *(*(++tmp)) = *ptr1;
    }

    /* restore globals */
    pds = saved_pds;
}

/* IV - Sep 17 2002: dummy user opcode function for not initialised case */

void useropcd(UOPCODE *p)
{
    sprintf(errmsg, "%s: not initialised", p->h.optext->t.opcod);
    perferror(errmsg);
}

/* IV - Sep 1 2002: new opcodes: xin, xout */

void xinset(XIN *p)
{
    OPCOD_IOBUFS  *buf;
    int         i, n, m;
    MYFLT       **tmp;

    buf = (OPCOD_IOBUFS*) p->h.insdshead->opcod_iobufs;
    if (buf == NULL) {
      initerror("xin is allowed only in user opcodes");
      return;
    }
    /* check number of arguments */
    if (p->OUTOCOUNT != buf->inchans || p->OUTOCOUNT > 24) {
      initerror("xin: invalid number of arguments");
      return;
    }
    /* check arg types, and copy i-time variables */
    for (i = 0, m = 1; i < p->OUTOCOUNT; i++, m <<= 1) {
      n = (p->XOUTCODE & (i < 15 ? m : 0));
      if ((buf->intypes[i] != 'a' && n) || (buf->intypes[i] == 'a' && !n)) {
        initerror("xin: invalid argument type");
        return;
      }
      /* if type is "i", "o", "p", "j", or "K", initialise now */
      if (buf->intypes[i] != 'a' || buf->intypes[i] != 'k')
        *(p->args[i]) = *(buf->inbufs[i]);
    }
    /* find a-rate variables and add to list of perf-time buf ptrs ... */
    tmp = buf->iobufp_ptrs;
    if (*tmp || *(tmp + 1)) {
      initerror("xin was already used in this opcode definition");
      return;
    }
    for (i = 0; i < p->OUTOCOUNT; i++)
      if (buf->intypes[i] == 'a') {
        *(tmp++) = buf->inbufs[i];      /* "from" address */
        *(tmp++) = p->args[i];          /* "to" address */
      }
    *(tmp++) = NULL;            /* put delimiter */
    /* ... same for k-rate */
    for (i = 0; i < p->OUTOCOUNT; i++)
      if (buf->intypes[i] == 'k' || buf->intypes[i] == 'K') {
        *(tmp++) = buf->inbufs[i];      /* "from" address */
        *(tmp++) = p->args[i];          /* "to" address */
      }
    *(tmp++) = NULL;            /* put delimiter */
    /* fix for case when xout is omitted */
    *(tmp++) = NULL; *(tmp++) = NULL;
}

void xoutset(XOUT *p)
{
    OPCOD_IOBUFS  *buf;
    int         i, n, m;
    MYFLT       **tmp;

    buf = (OPCOD_IOBUFS*) p->h.insdshead->opcod_iobufs;
    if (buf == NULL) {
      initerror("xout is allowed only in user opcodes");
      return;
    }
    /* check number of arguments */
    if (p->INOCOUNT != buf->outchans || p->INOCOUNT > 24) {
      initerror("xout: invalid number of arguments");
      return;
    }
    /* check arg types, and copy i-time variables */
    for (i = 0, m = 1; i < p->INOCOUNT; i++, m <<= 1) {
      /* the lowest two bits of XINCODE are swapped */
      n = (p->XINCODE & (i < 15 ? (i < 2 ? 3 - m : m) : 0));
      if ((buf->outtypes[i] != 'a' && n) || (buf->outtypes[i] == 'a' && !n)) {
        initerror("xout: invalid argument type");
        return;
      }
      /* if type is "i" or "K", initialise now */
      if (buf->outtypes[i] == 'i' || buf->outtypes[i] == 'K')
        *(buf->outbufs[i]) = *(p->args[i]);
    }
    /* find a-rate variables and add to list of perf-time buf ptrs ... */
    tmp = buf->iobufp_ptrs;
    while (*(tmp++) != NULL);   /* skip input pointers (a- and */
    while (*(tmp++) != NULL);   /* k-rate) */
    if (*tmp || *(tmp + 1)) {
      initerror("xout was already used in this opcode definition");
      return;
    }
    for (i = 0; i < p->INOCOUNT; i++)
      if (buf->outtypes[i] == 'a') {
        *(tmp++) = p->args[i];          /* "from" address */
        *(tmp++) = buf->outbufs[i];     /* "to" address */
      }
    *(tmp++) = NULL;            /* put delimiter */
    /* ... same for k-rate */
    for (i = 0; i < p->INOCOUNT; i++)
      if (buf->outtypes[i] == 'k' || buf->outtypes[i] == 'K') {
        *(tmp++) = p->args[i];          /* "from" address */
        *(tmp++) = buf->outbufs[i];     /* "to" address */
      }
    *(tmp++) = NULL;            /* put delimiter */
}

/* IV - Sep 8 2002: new opcode: setksmps */

void setksmpsset(SETKSMPS *p)
{
    int     l_ksmps;

    if ((OPCOD_IOBUFS*) p->h.insdshead->opcod_iobufs == NULL) {
      initerror("setksmps is allowed only in user opcodes");
      return;
    }
    l_ksmps = (int) *(p->i_ksmps);
    if (!l_ksmps) return;       /* zero: do not change */
    if (l_ksmps < 1 || l_ksmps > ksmps
        || ((ksmps / l_ksmps) * l_ksmps != ksmps)) {
      sprintf(errmsg, "setksmps: invalid ksmps value: %d", l_ksmps);
      initerror(errmsg);
      return;
    }
    /* set up global variables according to the new ksmps value */
    kcounter *= (ksmps / l_ksmps);
    ksmps = l_ksmps;
    ensmps = pool[O.poolcount + 2] = (MYFLT) ksmps;
    ekr = pool[O.poolcount + 1] = esr / ensmps;
    onedkr = FL(1.0) / ekr;
    hfkprd = FL(0.5) / ekr;
    kicvt = (MYFLT) FMAXLEN / ekr;
}

