typedef struct {                        /*                                      INSERT.H                */
        OPDS    h;
        LBLBLK  *lblblk;
} GOTO;

typedef struct {
        OPDS    h;
        int     *cond;
        LBLBLK  *lblblk;
} CGOTO;

typedef struct {
        OPDS    h;
        MYFLT   *idel, *idur;
        LBLBLK  *lblblk;
        long    cnt1, cnt2;
} TIMOUT;

typedef struct {
        OPDS    h;
} LINK;

/* IV - Sep 1 2002: moved these to insert.h */
typedef struct namedInstr {
        char  	*name;
        long	instno;
        INSTRTXT *ip;
        struct namedInstr *prv;
} INSTRNAME;

extern INSTRNAME *instrumentNames;

/* the number of optional outputs defined in entry.c */
#define SUBINSTNUMOUTS  8       /* IV - Sep 8 2002: for subinstruments ... */
#define OPCODENUMOUTS   24      /* ... and opcodes */

typedef struct {                /* IV - Sep 8 2002: restored struct for */
  	OPDS    h;              /* old sub-instruments */
  	MYFLT   *ar[VARGMAX];
  	INSDS  *ip;
        AUXCH   saved_spin;
  	AUXCH   saved_spout;
  	short	outchans;
  	short	usingNumberedInstr;	 /* a boolean */
	char	*outtypes;
	char	*intypes;
} SUBINST;

typedef struct {
    short   inchans, outchans;
    char    *intypes, *outtypes;
    MYFLT   **inbufs, **outbufs;
    MYFLT   **iobufp_ptrs;      /* IV - Sep 10 2002 */
} OPCOD_IOBUFS;

typedef struct {                /* IV - Sep 8 2002: new structure: UOPCODE */
    OPDS    h;
    MYFLT   *ar[VARGMAX];
    INSDS   *ip, *parent_ip;
    AUXCH   iobufs;             /* IV - Sep 1 2002 */
    OPCOD_IOBUFS  *buf;
    int     l_ksmps, ksmps_scale;
    MYFLT   l_ensmps, l_ekr, l_onedkr, l_hfkprd, l_kicvt;
} UOPCODE;

/* IV - Sep 8 2002: added opcodes: xin, xout, and setksmps */

typedef struct {
    OPDS        h;
    MYFLT       *args[OPCODENUMOUTS];
} XIN;

typedef struct {
    OPDS        h;
    MYFLT       *args[OPCODENUMOUTS + 8];       /* IV - Sep 17 2002 */
} XOUT;

typedef struct {
    OPDS        h;
    MYFLT       *i_ksmps;
} SETKSMPS;

